// Kleines HW-Testprogram für verbesserte Comedes-
// Luftentfeuchter-Steuerung mit ARDUINO Micro

int PinNTC    = A7;      // Misst Spannung des NTC-Spannungsteilers
int PinRelais = 12;      // Relais-Ansteuerung 
int PinLED    = 13;      // Onboard LED

void setup() 
{
   pinMode(PinRelais, OUTPUT);  
   pinMode(PinLED   , OUTPUT);  
   Serial.begin(19200);
  
   // Relais beim Starten ein paar Mal klackern lassen 
   // Kompressor dafür am besten abklemmen!
   int State = HIGH;
   for (int i=0; i<4; i++)
   {
      delay(500);          
      digitalWrite (PinRelais, State);  
      digitalWrite (PinLED   , State);  
      State = State ? LOW : HIGH;
   }
}

float ValueToTemp (int Val)
{
   float Temp; // Temp in °C
   const float a =  -0.00019318;  // quadratische Approximation, besser funktioniert jedoch 
   const float b =   0.28299193;  // die lineare Interpolation aus thermometer.h
   const float c = -63.74183261;
   
   Temp = a*Val*Val + b*Val + c;
   
   return Temp;
}


void loop() 
{
  int Val;
  
  Val = analogRead (PinNTC);
  Serial.print("Val ");
  Serial.print(Val);
  Serial.print(" -> ");
  Serial.print(ValueToTemp (Val),1 );
  Serial.println(" Grad Celsius");
  delay (1000);          
}

